| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::BEBLID Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing BEBLID (Boosted Efficient Binary Local Image Descriptor), described in [257] . More...

`#include <opencv2/xfeatures2d.hpp>`

Collaboration diagram for cv::xfeatures2d::BEBLID:

## Public Types
enum | BeblidSize { SIZE_512_BITS = 100 , SIZE_256_BITS = 101 }
| Descriptor number of bits, each bit is a boosting weak-learner. The user can choose between 512 or 256 bits. More...

## Public Member Functions
String | getDefaultName () const CV_OVERRIDE
virtual float | getScaleFactor () const =0
virtual void | setScaleFactor (float scale_factor)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< BEBLID > | create (float scale_factor, int n_bits=BEBLID::SIZE_512_BITS)
| Creates the BEBLID descriptor.
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing BEBLID (Boosted Efficient Binary Local Image Descriptor), described in [257] .

BEBLID [257] is a efficient binary descriptor learned with boosting. It is able to describe keypoints from any detector just by changing the scale_factor parameter. In several benchmarks it has proved to largely improve other binary descriptors like ORB or BRISK with the same efficiency. BEBLID describes using the difference of mean gray values in different regions of the image around the KeyPoint, the descriptor is specifically optimized for image matching and patch retrieval addressing the asymmetries of these problems.

If you find this code useful, please add a reference to the following paper:

> Iago Suárez, Ghesn Sfeir, José M. Buenaposada, and Luis Baumela. BEBLID: Boosted efficient binary local image descriptor. Pattern Recognition Letters, 133:366–372, 2020.

The descriptor was trained using 1 million of randomly sampled pairs of patches (20% positives and 80% negatives) from the Liberty split of the UBC datasets [299] as described in the paper [257]. You can check in the AKAZE example how well BEBLID works. Detecting 10000 keypoints with ORB and describing with BEBLID obtains 561 inliers (75%) whereas describing with ORB obtains only 493 inliers (63%).

## Member Enumeration Documentation

## ◆ BeblidSize

enum cv::xfeatures2d::BEBLID::BeblidSize

Descriptor number of bits, each bit is a boosting weak-learner. The user can choose between 512 or 256 bits.

Enumerator
SIZE_512_BITS |
SIZE_256_BITS |

## Member Function Documentation

## ◆ create()

static Ptr< BEBLID > cv::xfeatures2d::BEBLID::create | ( | float | scale_factor,
|  | int | n_bits = BEBLID::SIZE_512_BITS )
| static

Python:
| cv.xfeatures2d.BEBLID.create( | scale_factor[, n_bits] | ) -> | retval
| cv.xfeatures2d.BEBLID_create( | scale_factor[, n_bits] | ) -> | retval

Creates the BEBLID descriptor.

Parameters

  scale_factor | Adjust the sampling window around detected keypoints: 1.00f should be the scale for ORB keypoints 6.75f should be the scale for SIFT detected keypoints 6.25f is default and fits for KAZE, SURF detected keypoints 5.00f should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints
  n_bits | Determine the number of bits in the descriptor. Should be either BEBLID::SIZE_512_BITS or BEBLID::SIZE_256_BITS.

## ◆ getDefaultName()

String cv::xfeatures2d::BEBLID::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.xfeatures2d.BEBLID.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented from cv::Feature2D.

## ◆ getScaleFactor()

virtual float cv::xfeatures2d::BEBLID::getScaleFactor | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.BEBLID.getScaleFactor( |  | ) -> | retval

## ◆ setScaleFactor()

virtual void cv::xfeatures2d::BEBLID::setScaleFactor | ( | float | scale_factor | ) |
| pure virtual

Python:
| cv.xfeatures2d.BEBLID.setScaleFactor( | scale_factor | ) -> | None

The documentation for this class was generated from the following file:

- opencv2/xfeatures2d.hpp